#!/bin/bash

echo "Checking GitLab health status..."
if [ "$(docker inspect -f "{{.State.Health.Status}}" sharing_gitlab)" != "healthy" ]; then
  echo "sharing_gitlab is not healthy. Aborting!"
  exit 1
fi
echo "GitLab is healthy!"

echo "Creating application backup"
docker exec -t sharing_gitlab gitlab-backup create
echo "Application backup created"

echo "Creating secrets backup"
docker exec -t sharing_gitlab /bin/sh -c 'umask 0077; tar cfz /secret/gitlab/backups/$(date "+%s_%Y_%m_%d_etc_gitlab.tgz") -C /etc/gitlab .'
echo "Secrets backup created"
