package at.ac.uibk.gitsearch.service.gitlab_events;

import com.fasterxml.jackson.core.JacksonException;
import java.util.regex.Pattern;
import org.slf4j.LoggerFactory;

public interface MetaDataParser {
    enum FormatType {
        YAML,
        JSON,
    }

    enum ParserType {
        VERSION4(new MetaDatav04Parser()),
        VERSION4AND5(new MetaDatav05Parser()); // now supports versions 0.4 and 0.5

        @SuppressWarnings("unused")
        private static final org.slf4j.Logger LOGGER = LoggerFactory.getLogger(ParserType.class);

        @SuppressWarnings("unused")
        private static final Pattern METADATA_VERSION_DETECT = Pattern.compile("metadataVersion:\\W*'0.5'");

        private MetaDataParser mdParser;

        ParserType(MetaDataParser metaDataParser) {
            this.mdParser = metaDataParser;
        }

        public MetaDataParser getMetaDataParser() {
            return mdParser;
        }

        static ParserType getParserFor(String content) {
            return VERSION4AND5;
            //            if (METADATA_VERSION_DETECT.matcher(content).find()) {
            //                LOGGER.debug("Metadata v0.5 detected!");
            //                return VERSION5;
            //            } else {
            //                return VERSION4;
            //            }
        }
    }

    ExtendedUserProvidedMetadataDTO parse(String content, FormatType type) throws JacksonException;
}
