import { Component, OnInit } from '@angular/core';
import { ApplicationInfoService, DeploymentInfo } from 'app/core/application/applicationInfo.service';

@Component({
  selector: 'jhi-footer',
  templateUrl: './footer.component.html',
})
export class FooterComponent implements OnInit {
  deploymentInfo?: DeploymentInfo;
  commitInfoString = '---';

  constructor(public applicationInfoService: ApplicationInfoService) {}
  ngOnInit(): void {
    this.applicationInfoService.onDeploymentInfoChanged().subscribe(depInfo => {
      this.deploymentInfo = depInfo;
      this.updateFooter();
    });
    this.deploymentInfo = this.applicationInfoService.getDeploymentInfo();
    this.updateFooter();
  }

  getShortenedCommitId(): string {
    if (this.deploymentInfo?.commitId) {
      return this.deploymentInfo?.commitId.substring(0, 8);
    }
    return '---';
  }
  updateFooter() {
    if (this.deploymentInfo) {
      this.commitInfoString = `${this.deploymentInfo.branch}/${this.getShortenedCommitId()} (${this.deploymentInfo.deploymentDate})`;
    }
  }
}
