package at.ac.uibk.gitsearch.service;

import static org.hamcrest.Matchers.emptyOrNullString;
import static org.hamcrest.Matchers.is;
import static org.hamcrest.Matchers.not;

import at.ac.uibk.gitsearch.GitsearchApp;
import at.ac.uibk.gitsearch.service.dto.EditorialPageDTO;
import java.util.concurrent.TimeUnit;
import org.gitlab4j.api.GitLabApiException;
import org.hamcrest.MatcherAssert;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.Timeout;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.transaction.annotation.Transactional;

/**
 * Integration tests for {@link UserWatchListService}.
 */
@SpringBootTest(classes = GitsearchApp.class)
@Transactional
class EditorialPagesServiceIT {

    @Autowired
    private EditorialPagesService editorialPagesService;

    @Test
    @Timeout(value = 60, unit = TimeUnit.SECONDS) // gitlab may respond slowly
    void testSimplePage() throws GitLabApiException {
        EditorialPageDTO page = editorialPagesService.getContent("/de/start");
        MatcherAssert.assertThat(page.getContent(), not(is(emptyOrNullString())));
    }
}
