package at.ac.uibk.gitsearch.service;

import at.ac.uibk.gitsearch.GitsearchApp;
import at.ac.uibk.gitsearch.service.dto.BroadCastMessageDTO;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import java.io.IOException;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;
import java.util.stream.Collectors;
import org.hamcrest.MatcherAssert;
import org.hamcrest.Matchers;
import org.junit.Assert;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest(classes = GitsearchApp.class)
class MessageServiceIT {

    @Autowired
    MessageService messageService;

    @Test
    void loadMessages() throws JsonParseException, JsonMappingException, IOException {
        BroadCastMessageDTO[] messages = messageService.getMessages();
        if (messages == null) {
            // give it more time (or trigger reload)
            messageService.triggerReload();
            messages = messageService.getMessages();
        }

        Assert.assertNotNull("This may fail, due to timing problems", messages);
        Calendar end2023 = Calendar.getInstance();
        end2023.set(2024, 0, 1, 0, 0, 0);
        List<BroadCastMessageDTO> preparedTestMessages = Arrays
            .stream(messages)
            .filter(m -> m.getEnds_at().before(end2023.getTime()))
            .collect(Collectors.toList());

        MatcherAssert.assertThat(
            "This may fail, if there are changed old messages in gitlab",
            preparedTestMessages.size(),
            Matchers.greaterThanOrEqualTo(1)
        );
    }
}
